VERSION 5.00
Begin VB.Form frmDlgBox 
   Caption         =   "Files "
   ClientHeight    =   4425
   ClientLeft      =   90
   ClientTop       =   1485
   ClientWidth     =   5040
   LinkTopic       =   "Form1"
   ScaleHeight     =   4425
   ScaleWidth      =   5040
   Begin VB.CheckBox chkSorted 
      Caption         =   "Sorted"
      Height          =   375
      Left            =   3720
      TabIndex        =   6
      Top             =   3960
      Width           =   975
   End
   Begin VB.CheckBox chkPaths 
      Caption         =   "List Paths"
      Height          =   375
      Left            =   2400
      TabIndex        =   5
      Top             =   3960
      Width           =   1095
   End
   Begin VB.CheckBox ChkSubDir 
      Caption         =   "List Sub Folders"
      Height          =   375
      Left            =   120
      TabIndex        =   4
      Top             =   3960
      Width           =   1575
   End
   Begin VB.ListBox List1 
      Height          =   3180
      Left            =   2280
      TabIndex        =   3
      Top             =   720
      Width           =   2535
   End
   Begin VB.TextBox txtFileNames 
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Text            =   "*.*"
      Top             =   240
      Width           =   4695
   End
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   120
      TabIndex        =   1
      Top             =   3600
      Width           =   2055
   End
   Begin VB.DirListBox Dir1 
      Height          =   2790
      Left            =   120
      TabIndex        =   0
      Top             =   720
      Width           =   2055
   End
End
Attribute VB_Name = "frmDlgBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim Files(), NoSearch As Boolean
 
Private Const LB_SETHORIZONTALEXTENT = &H194

Private Declare Function SendMessage _
Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, _
    ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function GetDesktopWindow Lib "user32" () As Integer
Private Declare Function ShellExecute& Lib "shell32.dll" Alias "ShellExecuteA" (ByVal _
hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal _
lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long)
   
Public Sub DoFiles()
    List1.Clear
    If NoSearch Then FindFiles Dir1, txtFileNames, Files(), ChkSubDir
    If chkSorted Then SortArray Files(), 1
    For I = 1 To UBound(Files, 2) - 1
        If chkPaths Then
            List1.AddItem IFBACKSLASH(Files(0, I)) & Files(1, I)
            FL = IIf(Len(Files(0, I) & Files(1, I)) > FL, Len(Files(0, I) & Files(1, I)), FL)
        Else
            List1.AddItem Files(1, I)
            FL = IIf(Len(Files(1, I)) > FL, Len(Files(1, I)), FL)
        End If
    Next
    lngRtn = SendMessage(List1.hwnd, LB_SETHORIZONTALEXTENT, _
    FL * 6, ByVal 0&)

    Caption = List1.ListCount & " Files Found in Folder " & Dir1.Path
End Sub
Public Sub SortArray(ByRef DArray(), Element As Integer)
    Dim gap As Integer, doneflag As Integer, SwapArray()
    Dim Index As Integer
    ReDim SwapArray(2, UBound(DArray, 1), UBound(DArray, 2))
    'Gap is half the records
    gap = Int(UBound(DArray, 2) / 2)
    Do While gap >= 1
        Do
            doneflag = 1
            For Index = 0 To (UBound(DArray, 2) - (gap + 1))
                'Compare 1st 1/2 to 2nd 1/2
                If UCase(DArray(Element, Index)) > UCase(DArray(Element, (Index + gap))) Then
                    For acol = 0 To (UBound(SwapArray, 2) - 1)
                        'Swap Values if 1st > 2nd
                        SwapArray(0, acol, Index) = DArray(acol, Index)
                        SwapArray(1, acol, Index) = DArray(acol, Index + gap)
                    Next
                    For acol = 0 To (UBound(SwapArray, 2) - 1)
                        'Swap Values if 1st > 2nd
                        DArray(acol, Index) = SwapArray(1, acol, Index)
                        DArray(acol, Index + gap) = SwapArray(0, acol, Index)
                    Next
                    CNT = CNT + 1
                    doneflag = 0
                End If
            Next
        Loop Until doneflag = 1
        gap = Int(gap / 2)
    Loop
End Sub
Private Function IFBACKSLASH(strX) As String
    ' function for fixing the DOS path of a root directory
     IFBACKSLASH = IIf(Right(strX, 1) = "\", strX, strX & "\")
End Function

Private Sub chkPaths_Click()
    NoSearch = False
    DoFiles
End Sub

Private Sub chkSorted_Click()
    NoSearch = False
    DoFiles
End Sub

Private Sub ChkSubDir_Click()
    NoSearch = True
    DoFiles
End Sub

 Private Sub Dir1_Change()
    NoSearch = True
    DoFiles
 End Sub

Private Sub Drive1_Change()
    Dir1.Path = Left(Drive1.Drive, 2) & "\"
End Sub

Public Sub FindFiles(strPARENT As String, FindFile As String, ByRef FilesFound(), SearchSubs As Boolean)
    'EXAMPLE:
    ' FindFiles Dir1.Path, arrayPointers, arrayFilenames
    On Error GoTo ErrorH
    MousePointer = 11
    ReDim FilesFound(2, 0)
    Set objFSO = New FileSystemObject
    'The result in is used to fill a listbox.
    If FindFile = "" Then Exit Sub
    Dim lngTopIndex As Long, lngPathIndex As Long, strNextPath As String
    Dim UStart As Boolean, UEnd As Boolean, Found As Boolean, StrSize As Long
    Dim strPaths() As String
    ReDim FType(1, 0)
    Dim FileName() As String, FileNo As Single, UFlag() As Boolean, Matches As Integer
    ReDim FileName(1)
    FileNo = 1
    FileNo = InStr(FileNo, FindFile, ";", vbTextCompare)
    FileName(0) = Mid(FindFile, 1, IIf(FileNo > 0, FileNo - 1, Len(FindFile)))
    Do While FileNo <> 0
        ReDim Preserve FileName(UBound(FileName) + 1)
        FileName(UBound(FileName) - 1) = Mid(FindFile, FileNo + 1, IIf(FileNo > 0, _
        IIf(InStr(FileNo + 1, FindFile, ";", vbTextCompare) > 0, InStr(FileNo + 1, _
        FindFile, ";", vbTextCompare) - (FileNo + 1), Len(FindFile) - FileNo), FileNo - 1))
        FileNo = InStr(FileNo + 1, FindFile, ";", vbTextCompare)
    Loop
    ReDim UFlag(3, UBound(FileName))
    ReDim FileCount(UBound(FileName))
    g = 1
    For I = 0 To UBound(FileName) - 1
        UFlag(0, I) = False
        UFlag(1, I) = False
        UFlag(2, I) = False
        Do
            g = InStr(g, FileName(I), "*")
            If g = 1 Then
                UFlag(0, I) = True
                FileName(I) = Right(FileName(I), (Len(FileName(I)) - 1))
            End If
            If g = Len(FileName(I)) Then
                UFlag(1, I) = True
                FileName(I) = Left(FileName(I), Len(FileName(I)) - 1)
            End If
            If g <> 0 Or g = Len(FileName(I)) Then g = g + 1
        Loop Until g = 0
        g = 1
    Next
    'Remove *s form the search string
    ' "seed" the loop
    lngTopIndex = 0
    lngPathIndex = 0
    lngFNAMEScntr = 0
    ReDim strPaths(0)
    strPaths(0) = IFBACKSLASH(strPARENT)
    
    Do
        If SearchSubs Then 'SubFolders
            'Creates a folders object containing the subfolders and files
            Set objFolders = objFSO.GetFolder(strPaths(lngPathIndex)).SubFolders
            ' Add subfolders, if any, to folder array
            For Each objFolder In objFolders
                'Increment the folder counter
                lngTopIndex = lngTopIndex + 1
                'Create an additional element in the array
                ReDim Preserve strPaths(lngTopIndex)
                'Store the previous path and the current folder to the path array
                strPaths(lngTopIndex) = strPaths(lngPathIndex) & objFolder.Name & "\"
            Next
        End If
        Set objFiles = objFSO.GetFolder(strPaths(lngPathIndex)).Files
        DoEvents
        ' Add filenames, if any, to array
        For Each objfile In objFiles
            Found = False
            'No Wildcards looks for the exact file name
            For I = 0 To UBound(FileName) - 1
                'This next section determines if there is a wild card indicator before
                'and or after the string to locate
                If Not UFlag(0, I) And Not UFlag(1, I) And Not UFlag(2, I) Then
                    If objFSO.FileExists(strPaths(lngPathIndex) & FileName(I)) Then
                        List1.AddItem strPaths(lngPathIndex) & FileName(I)
                        UFlag(2, I) = True
                        FileCount(I) = FileCount(I) + 1
                    End If
               End If
                If Len(objfile.Name) <= Len(FileName(I)) Then Exit For
                'If the wild card indicator is before and after all finds are located
                If UFlag(0, I) And UFlag(1, I) Then
                    If InStr(1, UCase(objfile.Name), UCase(FileName(I))) > 0 Then Found = True
                End If
                'Identifies only those filenames with the Wildcard at the start of the string
                If UFlag(0, I) And Not UFlag(1, I) Then
                    If InStr((Len(objfile.Name) - Len(FileName(I))), UCase(objfile.Name), UCase(FileName(I))) > 0 Then Found = True
                End If
                'Identifies only those file names with a Wildcard at the end of the string
                If UFlag(1, I) And Not UFlag(0, I) Then
                    If InStr(1, Left(UCase(objfile.Name), Len(FileName(I))), UCase(FileName(I))) > 0 Then Found = True
                End If
                If Found Then
                    ReDim Preserve FilesFound(2, (UBound(FilesFound, 2) + 1))
                    FilesFound(1, UBound(FilesFound, 2)) = objfile.Name
                    FilesFound(0, UBound(FilesFound, 2)) = strPaths(lngPathIndex)
                    FileCount(I) = FileCount(I) + 1
                    Exit For
                End If
                If Cancel Then
                    MousePointer = 0
                    Exit Sub
                End If
            Next
        Next
          
        ' Point to next entry in subfolder array
          lngPathIndex = lngPathIndex + 1
          
        ' If there are no more subfolders, exit
    Loop Until lngPathIndex > lngTopIndex
    MousePointer = 0
    Exit Sub

ErrorH:
    Stop
    Resume Next
End Sub

Function StartDoc(DocName As String) As Integer
    Dim Scr_hDC As Integer
    Scr_hDC = GetDesktopWindow()
    StartDoc = ShellExecute(hwnd, "open", DocName, vbNullString, CurDir$, SW_SHOW)
End Function
Private Sub Form_Load()
    NoSearch = True
    Dir1_Change
End Sub

Private Sub List1_DblClick()
    Dim DI As Integer, FileName As String
    FileName = IFBACKSLASH(Files(0, List1.ListIndex + 1)) & Files(1, List1.ListIndex + 1)
    DI = StartDoc(FileName)
End Sub

Private Sub txtFileNames_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = 13 Then Dir1_Change
End Sub

